namespace PeteBrown.NetduinoMidiTest.Messages
{
    public struct MidiMessage
    {
        public MidiMessageNumber MessageNumber;
        public MidiChannel Channel;
        public byte DataByte1;
        public byte DataByte2;
        public int DataBytesCombined;

        public bool IsDataByte2Used;
        public bool IsCombinedData;

        public override string ToString()
        {
            // no string.format in the NETMF
            string result = "Ch: " + Channel +
                        " Msg: " + MessageNumber.ToString();

            if (IsCombinedData)
                result += " DataWord: " + DataBytesCombined;
            else
            {
                result += " DataByte1:" + (int)DataByte1;

                if (IsDataByte2Used)
                    result += " DataByte2:" + (int)DataByte2;
            }

            return result;
        }
    }
}
