﻿using System;
using System.Threading;
using Microsoft.SPOT;
using Microsoft.SPOT.Hardware;
using SecretLabs.NETMF.Hardware;
using SecretLabs.NETMF.Hardware.Netduino;
using System.IO.Ports;


namespace PeteBrown.NetduinoMidiTest
{
    public class Program
    {
        private static OutputPort _onboardLed = 
            new OutputPort(Pins.ONBOARD_LED, false);

        private static MidiMessageReceiver _midiIn = new MidiMessageReceiver();

        public static void Main()
        {
            _midiIn.MessageReceived += new MidiMessageReceivedEventHandler(OnMidiMessageReceived);
            _midiIn.Open();

            // wait forever
            Thread.Sleep(Timeout.Infinite);
        }

        static void OnMidiMessageReceived(object sender, MidiMessageReceivedEventArgs args)
        {
            Debug.Print(args.Message.ToString());

            if (args.Message.MessageNumber == Messages.MidiMessageNumber.NoteOn)
            {
                if (args.Message.DataByte2 == 0)
                {
                    // a note on with velocity of zero is really a note off. LAME
                    _onboardLed.Write(false);
                }
                else
                {
                    _onboardLed.Write(true);
                }
            }

            if (args.Message.MessageNumber == Messages.MidiMessageNumber.NoteOff)
                _onboardLed.Write(false);
        }
    }
}
